<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function() {
    onPageLoading();
  })  
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //hàm xử lý sự kiện load trang
  function onPageLoading() {
    $.ajax({
        url:  "http://203.171.20.210:8080/crud-api/users/",
        type: 'GET',
        dataType: 'json', // added data type
        success: function(res) {
            console.log(res);
            loadDataToTable(res);
        },
        error: function (ajaxContext) {
            alert(ajaxContext.responseText)
        }
    }); 
  }

  //hàm xử lý sự kiện click nút sửa
  function onBtnEditClick(paramEdit) {
    console.log('edit id = ' + paramEdit.dataset.id);
  }

  //hàm xử lý sự kiện click nút xóa
  function onBtnDeleteClick(paramDelete) {
    console.log('delete id = ' + $(paramDelete).data('id'));
  }  
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm load dữ liệu vào table
  function loadDataToTable(paramUsers) {
    var vTableUsers = $("#table-users");

    //thêm các row và cell
    for (var bI = 0; bI < paramUsers.length; bI++) {
        //thêm row
        var vNewRow = $("<tr>").appendTo(vTableUsers);

        //thêm cell
        $("<td>", {html:paramUsers[bI].id}).appendTo(vNewRow);        
        $("<td>", {html:paramUsers[bI].firstname}).appendTo(vNewRow);        
        $("<td>", {html:paramUsers[bI].lastname}).appendTo(vNewRow);     
        $("<td>", {html:paramUsers[bI].country}).appendTo(vNewRow); 
        $("<td>", {html:paramUsers[bI].subject}).appendTo(vNewRow);     
        $("<td>", {html:paramUsers[bI].customerType}).appendTo(vNewRow);     
        $("<td>", {html:paramUsers[bI].registerStatus}).appendTo(vNewRow);  
        //vNewRow.append("<td><button class='btn btn-primary'>Sửa</button></td>");
        var vColAction = $("<td>").appendTo(vNewRow);    
        vColAction.append("<button class='btn btn-primary' data-id='" + paramUsers[bI].id + "' onclick='onBtnEditClick(this)'>Sửa</button>");  
        $("<button>", {
            html:'Xóa',
            class:'btn btn-danger',
            onclick:'onBtnDeleteClick(this)'            
        })
        .attr("data-id",paramUsers[bI].id)
        .appendTo(vColAction);

    }
  }
</script>
</html>
